/// <reference types="react" />
import type { ExtractArray } from "./types";
export declare class ParamsValidation<T = never> {
    private _rules?;
    private regexes;
    constructor(_rules?: {
        string: boolean | RegExp | import("react").ReactText[];
        number: boolean | RegExp | import("react").ReactText[];
        enum: boolean | RegExp | import("react").ReactText[];
        regex: boolean | RegExp | import("react").ReactText[];
        optional: boolean | RegExp | import("react").ReactText[];
    } | undefined);
    generateRules: (paramKey: string) => string | undefined;
    enum<Keys extends Array<number | string>>(...keys: Keys): ParamsValidation<T | ExtractArray<Keys>>;
    get string(): ParamsValidation<string | T>;
    regex(reg: RegExp): ParamsValidation<string | T>;
    get number(): ParamsValidation<number | T>;
    get optional(): ParamsValidation<T | undefined>;
}
